> For the complete documentation index, see [llms.txt](https://docs.talus.network/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.talus.network/talus-docs-v2.1.0/reference/move/nexus_primitives/shared_object.md).

# shared\_object

* [Struct `SharedObjectRef`](#struct-sharedobjectref)
* [Function `shared_object_ref_imm`](#function-shared_object_ref_imm)
* [Function `shared_object_ref_mut`](#function-shared_object_ref_mut)
* [Function `shared_object_id`](#function-shared_object_id)
* [Function `shared_object_ref_mutable`](#function-shared_object_ref_mutable)

### Struct `SharedObjectRef`

Describes how a shared object is passed to an interface Move call.

```move
public struct SharedObjectRef has copy, drop, store
```

<details>

<summary>Fields</summary>

`id: sui::object::ID`The ID of the shared object.`ref_mut: bool`Whether the object is passed by mutable reference.

</details>

#### Function `shared_object_ref_imm`

Helper to create [`SharedObjectRef`](#nexus_primitives_shared_object_SharedObjectRef) with immutable reference.

```move
public fun shared_object_ref_imm(id: sui::object::ID): nexus_primitives::shared_object::SharedObjectRef
```

#### Function `shared_object_ref_mut`

Helper to create [`SharedObjectRef`](#nexus_primitives_shared_object_SharedObjectRef) with mutable reference.

```move
public fun shared_object_ref_mut(id: sui::object::ID): nexus_primitives::shared_object::SharedObjectRef
```

#### Function `shared_object_id`

The ID of the referenced shared object.

```move
public fun shared_object_id(self: &nexus_primitives::shared_object::SharedObjectRef): sui::object::ID
```

#### Function `shared_object_ref_mutable`

Whether the shared object is passed by mutable reference.

```move
public fun shared_object_ref_mutable(self: &nexus_primitives::shared_object::SharedObjectRef): bool
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.talus.network/talus-docs-v2.1.0/reference/move/nexus_primitives/shared_object.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `build a script that syncs our docs to a CMS` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
